#ifndef __chebyshev__
#define __chebyshev__
#include <cmath>
#include "resummation.hh"


enum Lum_type {
  //Lum_manip = 0,
  Lum_log = 1,
  Lum_plus = 2,
  Lum_plus_log1z = 3
};

class Chebyshev {
public:
  Chebyshev(resumm::Resummation *r);
  ~Chebyshev();
  //
  int ApproxLuminosity   (double *coeff, unsigned int N=10, double beta=3., int gamma=5, double z_min=1.e-5);
  //int ApproxLuminosity_log(double *coeff, unsigned int N=15, double z_min=1.e-6);
  int ApproxLumPlus      (double *coeff, double x, unsigned int N=10);
  int ApproxLumPlus_log1z(double *coeff, double x, unsigned int N=10);
  //
  void EnableQualityCheck(bool enable=true);

  /*
  int cheb_approx_borel_rap(double Y, double x, double *coeff_borel, unsigned int N_plus=15);
  //int cheb_approx_borel_rap_BNX(int pm, double Y, double x, double *coeff_borel, unsigned int N_plus=15);
  int cheb_approx_luminosity_rap(double Y, double *coeff_lum, unsigned int N_lum=20, double beta=5., double gamma=6.);
  int cheb_approx_luminosity_rap_log(double Y, double z_min, double *coeff_lum, unsigned int N_lum=15);
  */

private:
  double beta_lum;
  int gamma_lum;
  bool quality_check;
  resumm::Resummation *res;
  //double (*Lum)(double);
  //double Lum(double);
  double fLum_manipulated(double z, void *p);
  double fLum_log(double x, void *p);
  double fLum_plus(double z, void *p);
  double fLum_plus_log1z(double t, void *p);
  double Lum_func(Lum_type, double, void*);
  //
  /*
  double rec_Lum_plus(double *c, int N, double z);
  double rec_Lum_plus_log1z(double *c, int N, double z);
  double rec_Lum(double *c, int N, double z);
  double rec_Lum_func(Lum_type, double, double*, int);
  */
  friend double integrand_QC(double z, void *p);
  //
  int cheb_approx(Lum_type, unsigned int, const double, const double, double *, void *p=NULL);


};








#endif
