#include "complex.hh"
#include <iomanip>
//#include <gsl/gsl_sf_gamma.h>


// stream operators
istream & operator >> (istream& is, complex & a){
  return is >> a.r  >> a.i;
}
ostream & operator << (ostream & os, const complex & a){
  int sign = a.i>=0 ? 1 : -1;
  string ssign = sign>0 ? " + i " : " - i ";
  double im = a.i==0. ? 0. : a.i/sign;
  return os << "( "  << setw(11) << a.r 
	    << ssign << setw(11) << im  << " )" ;
}


