#ifndef __special_functions_H
#define __special_functions_H

#include "complex.hh"

const double PI_DEF =  3.1415926535897932385;
const double PISQ   =  9.86960440108935861883;
const double ZETA2  =  1.64493406684822643647;
const double PISQ6  =  1.64493406684822643647;
const double PI4    = 97.409091034002437236440;
const double ZETA3  =  1.2020569031595942855;
const double ZETA4  =  1.082323233711138191516;
const double ZETA5  =  1.036927755143369926331;
const double EulerGamma = 0.5772156649015328606065120900824;


template<class T>
inline T SQR(T a){return a*a;}

//extern double  Round(double x, int n_decimals);
//extern complex Round(complex x, int n_decimals);

extern double ABS(double a); 
extern int    ABS(int a);

extern double MIN (double a,double b);
extern double MAX (double a, double b);
extern double SIGN(double a, double b);

extern int MIN (int a, int b);
extern int MAX (int a, int b);
extern int SIGN(int a, int b);

extern int INT(double a);
extern bool isINT(double a);




extern complex logGamma(complex z);
extern complex Gamma(complex z);

extern complex  TruncatedGamma(const complex a, const double x);
extern complex IncompleteGamma(const complex a, const double x);
extern complex IncompleteBeta (const complex a, const complex b, const double x);

extern complex psi(complex z);




# endif    /*  DILOG_H   */
